# ------------------------------------------------------------------------
#   EmailHTML.pm -- HTMLեMIMEޥѡȤѴ
# ------------------------------------------------------------------------
#   2004/11/03  ǽΥС
#   2004/11/07  POD 򾯤ޤ
# ------------------------------------------------------------------------
    package EmailHTML;
    use strict;
    use vars qw( $VERSION $DEBUG );
# ------------------------------------------------------------------------
    $VERSION = "0.01";
# ------------------------------------------------------------------------
=head1 NAME

    EmailHTML.pm -- html file into mime multipart message

=head1 SYNOPSIS

    # HTML᡼ץץ

    use strict;
    use EmailHTML;
    use Net::SMTP;

    # 

    my $SMTP_HOST = "127.0.0.1";
    my $MAIL_FROM = 'from@domain.name';
    my $MAIL_RCPT = 'to@domain.name';
    my $URL = "http://www.domain.name/i/";

    #  URL Ƥ HTML ᡼

    my $eh = new EmailHTML( URL => $URL );
    $eh->set_header( From => $MAIL_FROM );
    $eh->set_header( To => $MAIL_RCPT );
    my $data = $eh->out_text();

    # Net::SMTP Ȥäƥ᡼

    my $smtp = new Net::SMTP( $SMTP_HOST ) or die "SMTP Failed - $SMTP_HOST\n";
    $smtp->mail( $MAIL_FROM ) or die "Invalid sender - $MAIL_FROM\n";
    $smtp->to( $MAIL_RCPT ) or die "Invalid receipts - $MAIL_RCPT\n";
    $smtp->data();
    $smtp->datasend( $data );
    $smtp->dataend();
    $smtp->quit();

=head1 DESCRIPTION

    ꤷURLHTMLɤեޤ
    MIME ޥѡȷˤ HTML ᡼Ѵޤ

    ڡβ⼫ưŪ˥ɤ졢Base64󥳡ɤޤ
    HTML  IMG  <IMG SRC="cid:"> Ƚ񤭴ޤ
    NTTɥⰸΥǥ᡼ѤǤޤ

    Outlook ExpressBecky! 2 ɽǤ뤳ȤϤ
    NTT DoCoMo 900i ꡼Υǥ᡼ȤƤǤޤ
    ǥ᡼¤ˤꡢեޤ᤿̤
    10KB ʲȤʤäƤɬפޤ
    10KB Ķϡ900i µǼ
    ñʤեźե᡼ȤʤäƤ뤿ᡢդ

    HTML ʸɤϥɤޤѹޤ
    о Shift_JIS ΥƥĤϡ᡼Ǥ Shift_JIS ˤʤޤ
    ISO-2022-JPEUC-JPUTF-8ISO-8859-1US-ASCII ʤɤѲǽǤ
    UCS-2 ʤɤ 16bit ʸѤǤޤ

    <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=Shift_JIS"> 

    Τ褦 META ʸɤꤵ줿ϡΥɤȤߤʤޤ
    META ʸɤꤵʤϡShift_JISEUC-JPUTF-8ν
    ưȽ̤ޤʥץǼưȽ̤ OFF ˤ뤳ȤǽǤ
    ʸɤμưȽ̤˼Ԥϡʸɤ(̵)Ȥʤޤ

    EmailHTML.pm ΤѴΤߤԤ᡼ϹԤޤ
    ᡼ϡNet::SMTP ⥸塼ʻѤ뤫
    out_file() ᥽åɤ sendmail ưƥ᡼Ƥ

=head1 METHODS

new() 󥹥ȥ饯

    my $eh = new EmailHTML( 
        URL          =>  "http://www.yahoo.co.jp/", # URL
        HTML         =>  undef,                     # ɤ߹ߤʤ
        HTML_BASE64  =>  undef,                     # HTMLʬBase64
        HTML_QP      =>  undef,                     # HTMLʬQP
        USER_AGENT   =>  "DoCoMo/0.0/SH900i/c100",  # HTTP_USER_AGENT
        TZ           =>  "+0900",                   # Date:إåTIMEZONE
        DETECT_SJIS  => 1,      # Shift_JIS ưФ
        DETECT_EUCJP => 1,      # EUC-JP ưФ
        DETECT_UTF8  => 1,      # UTF-8 ưФ
    );

    HTML Ǥϡ URL ƤͽɺѤߤκݤ˻Ǥޤ
    HTML ΥɤϹԤޤ
    HTML βեϥɤޤ

    HTML_BASE64 򿿤ˤ硢եǤʤޥѡ
    HTML ʬˤĤƤ Base64 󥳡ɤޤ
    ǥեȤǤϡɻʸɤΤޤǡǽϤޤ

    HTML_QP 򿿤ˤϡHTML ʬ Quoted-Pritable ˤޤ
    ᡼ϩ 7bit ξʤɤͭǤ

    USER_AGENT ϡHTML ե HTTP ͳǥɤݤ
    Ѥ֥饦̾ꤷޤ
    ¦ǥ֥饦äưȽ̤ƤݤˤѤǤޤ

    TZ ϡ᡼إå Date: Ԥǻꤹ륿ॾꤷޤ
    ǥեȤǤ +0900ɸˤȤʤޤ

    DETECT_SJISDETECT_EUCJPDETECT_UTF8 ϡ
    META ˤä HTML ʸɤꤵʤäˡ
    HTML ƤʸɤưȽ̤뤫ݤꤷޤ
    ξϡưȽ̤ޤξϼưȽ̤ޤ

    DETECT_SJIS ξϡShift_JISʢCP932IBMĥ
    óʸޤˤȤƤꤨʤХ󤬣ХȤ
    ޤޤʤˡShift_JIS ȤȽ̤ޤ

    DETECT_EUCJP ξϡEUC-JP ȤƤꤨʤХ
    ХȤޤޤʤˡEUC-JP ȤȽ̤ޤ

    DETECT_UTF8 ξϡUTF-8 ȤƤꤨʤХ
    ХȤޤޤʤˡUTF-8 ȤȽ̤ޤ

    Shift_JISEUC-JPUTF-8 ̤ͥȽ̤ޤ
    ܸڡܥ⥸塼Ѥϡƿ򤪴ᤷޤ
    ܸʳΥڡˤѤϡƵ򤪴ᤷޤ
    META ʤưȽ̤⤷ʤäϡʸɤ̵Ȥʤ
    ᡼륽ե¦ʤ HTML ɽ⥸塼ˤ HTML ʸɼưȽ
    ˰¸ޤ

set_header() ᥽å

    $eh->set_header( From => 'from@domain.name' );
    $eh->set_header( To => 'to@domain.name' );
    $eh->set_header( "X-Mailer" => "Microsoft Outlook Express" );

    ᡼إåꤷޤ
    ǥեȤǤϡʲΥإåưޤ

        Date:           out_text ᥽åɤƤӽФ
        Subject:        HTML<TITLE></TITLE>
        Content-Type:   multipart/related
        MIME-Version:   1.0ʸ
        Content-Transfer-Encoding:  7bit ޤ 8bitʼư
        X-Mailer:       USER_AGENT

    set_header ᥽åɤǻꤵƤϡư
    set_header ᥽åɤǻꤵ줿Ƥͥ褵ޤ

    my $head = {
        "From"     => 'from@domain.name',
        "To"       => 'to@domain.name',
        "X-Mailer" => "Microsoft Outlook Express",
    };
    $eh->set_header( %$head );

    Τ褦ʣΥ᡼إåꤹ뤳ȤǽǤ

out_text() ᥽å

    print $eh->out_text();

    HTML Ƥȥڡβեɤơ
    MIME ޥѡȷΥƥ(ʸ)ȤƼФޤ

out_file() ᥽å

    $eh->out_file( "/tmp/sample.eml" );

    out_file ϡMIME ޥѡȷΥƥȤȤƼФ
    ꤷե㤨 sample.emlˤ˥᡼Ƥ񤭹ߤޤ

    $eh->out_file( "| /usr/sbin/sendmail -t -oi" );

    裱|ɤǻϤ뤳ȤǳޥɤǤޤ
    sendmail ѤƤΤޤޥ᡼Ǥ
    -t ץˤ᡼ To: Cc: Bcc: ԤȤޤ

get_html() ᥽å
set_html() ᥽å

    my $content = $eh->get_html();
    $content =~ s#(</?)(\w+)#$1.uc($2)#g;
    $eh->set_html( $content );

    HTML Υ <br><BR> Τ褦ʸǤ
    get_html ᥽åɤǤϡMIME ޥѡȲƽϤˡ
    HTML ƤԼǤޤ
    㤨ʸʤɤνԤä set_html ᥽åɤϤȤǡ
    HTML Ƥ񤭴뤳ȤǽǤ
    get_html ᥽åɤƤӽФ set_html ᥽åɤƤ֤ȤǽǤ
    HTML ƤޤäƤʤɤ HTTP ɤʤȤǤޤ

get_encoding() ᥽å
set_encoding() ᥽å

    get_encoding ϡHTML ʸ(charset=)ޤ
    META λƤλȤޤϡХˤ뼫ưȽ̤Ȥʤޤ
    get_html γǧѤǤޤEmailHTML.pm Ǥʸɤ
    ưѴϹԤޤJcode.pm  Encode.pm ʤɤʻѤƤ

    set_encoding ϡHTML ʸ(charset=)ꤷޤ
    META λƤ䡢ХμưȽ̤ͥ褵ޤ
    set_html ƤʸɤΤξͭǤ礦

=head1 COPYRIGHT

    Copyright 2004 Kawasaki Yusuke <u-suke@kawa.net>
    http://www.kawa.net/

=cut
# ------------------------------------------------------------------------
    use MIME::Base64;           # MIMEإåե沽
    use LWP::UserAgent;         # HTTP 
# ------------------------------------------------------------------------
#   󥹥ȥ饯 new() Υǥեȥץ
# ------------------------------------------------------------------------
    my $DEFAULT_ARG = {
        # ǥեͤΤʤѿ
        URL         =>  undef,      # URL
        HTML        =>  undef,      # 
        HTML_BASE64 =>  undef,      # 
        HTML_QP     =>  undef,      # 

        # HTTP ɻѤ User-Agent:ʥ֥饦̾
        USER_AGENT  =>  "EmailHTML/".$VERSION,

        # ᡼إåѤ Date: ѥॾ
        TZ          =>  "+0900",

        # HTML ʸʸɼưȽ̤Ԥݤ
        DETECT_SJIS  => 1,      # Shift_JIS ưФ
        DETECT_EUCJP => 1,      # EUC-JP ưФ
        DETECT_UTF8  => 1,      # UTF-8 ưФ
    };
# ------------------------------------------------------------------------
#   ᡼θ
# ------------------------------------------------------------------------
    my $BOUNDREL = "EN-REL-1";
    my $BOUNDALT = "EN-ALT-1";
    my $MULTIPART_MESS = "This is a multi-part message in MIME format.";
# ------------------------------------------------------------------------
#   URLHTMLեMIMEޥѡȤѴ
# ------------------------------------------------------------------------
sub new {
    my $package = shift;
    my $obj = {};
    bless $obj, $package;
    $obj->{arg} = { @_ };       # ϥåˤ

    # ǥեͤ

    foreach my $key ( keys %$DEFAULT_ARG ) {
        next if defined $obj->{arg}->{$key};
        $obj->{arg}->{$key} = $ENV{$key} || $DEFAULT_ARG->{$key};
    }

    $obj;
}
# ------------------------------------------------------------------------
#   إåꤹ
# ------------------------------------------------------------------------
sub set_header {
    my $obj = shift or return;
    $obj->{header} ||= {};              # Ͻ

    while ( $#_ > 0 ) {
        my $key = shift;
        my $val = shift;
        $key =~ s/[^\w\-]/-/sg;             # ѿϥեΤߵ
        $key =~ s/^([a-z])/uc($1)/se;       # Ƭɬʸˤ
        $obj->{header}->{$key} = $val;
        $DEBUG and print STDERR "[$key=$val]\n";
    }

    $obj->{header};
}
# ------------------------------------------------------------------------
#   ƥȥѡȤꤹ
# ------------------------------------------------------------------------
sub set_text {
    my $obj = shift or return;
    $obj->{text} = shift;
    $obj->{text_charset} = shift;
}
# ------------------------------------------------------------------------
#   ƥȥѡȤФ
# ------------------------------------------------------------------------
sub get_text {
    my $obj = shift or return;
    return unless defined $obj->{text};
    wantarray ? ( $obj->{text}, $obj->{text_charset} ) : $obj->{text};
}
# ------------------------------------------------------------------------
#   HTML Τꤹ
# ------------------------------------------------------------------------
sub set_html {
    my $obj = shift or return;
    $obj->{html} = shift;
}
# ------------------------------------------------------------------------
#   HTML ΤФʥ顼֤
# ------------------------------------------------------------------------
sub get_html {
    my $obj = shift or return;
    my $ref = $obj->get_html_ref();
    return unless ref $ref;
    $$ref;
}
# ------------------------------------------------------------------------
#   HTML ΤФʥե󥹤֤
# ------------------------------------------------------------------------
sub get_html_ref {
    my $obj = shift or return;
    return \$obj->{html} if defined $obj->{html};           # å
    return \$obj->{arg}->{HTML} if defined $obj->{arg}->{HTML};
    my $argurl = $obj->{arg}->{URL} or return;              # URLǧ
    $obj->{html} = $obj->http_download( $argurl );          # HTTP
    \$obj->{html};
}
# ------------------------------------------------------------------------
#   󥳡ǥ󥰤ꤹ
# ------------------------------------------------------------------------
sub set_encoding {
    my $obj = shift or return;
    $obj->{html_charset} = shift or return;
}
# ------------------------------------------------------------------------
#   󥳡ǥ󥰤֤
# ------------------------------------------------------------------------
sub get_encoding {
    my $obj = shift or return;
    return $obj->{html_charset} if defined $obj->{html_charset}; # å
    $obj->{html_charset} = $obj->detect_charset();                # ưȽ
}
# ------------------------------------------------------------------------
#   HTML  RFC822 .emlˤǼФʥե񤭹ߡ
# ------------------------------------------------------------------------
sub out_file {
    my $obj = shift or return;
    my $eml = shift or return;

    my $open = ( $eml =~ /^[\|\&\>]/ ) ? $eml : "> $eml";
    open( EML, $open ) or die "$! - $eml\n";
    print EML $obj->out_text();
    close( EML );

    $eml;
}
# ------------------------------------------------------------------------
#   HTML  RFC822 .emlˤǼФʥƥȡ
# ------------------------------------------------------------------------
sub out_text {
    my $obj = shift or return;

    # HTML Ф

    my $argurl = $obj->{arg}->{URL};
    my $content = $obj->get_html();
    my $encode = $obj->get_encoding();
    $DEBUG and print STDERR "[encode=$encode]\n";

    # ԥɤ줹

    $content =~ s#\r\n#\n#sg;
    $content =~ s#\r#\n#sg;

    # ڡȥʤ MIME 󥳡ɤ

    my $title = ( $content =~ m#<TITLE[^>]*>(.*?)</TITLE[^>]*>#is )[0];
    $title =~ s/\s+/ /g;
    $DEBUG and print STDERR "[title=$title]\n";

    # ʸɤΤʤ顢ץ󥹤ޤ2Хȥɰʹߡ
    # ζμ(ʤʸ)ޤǤƤʸBASE64 Ƥޤ
    # 2Хʸ ASCII  BASE64 Ƥޤ³Ϥʤʤȡ

    if ( $encode ) {
        $title =~ s{
            ([\e\x80-\xFF]\S*)
        }{
            "=?$encode?B?".MIME::Base64::encode_base64($1, "")."?=";
        }egx;
        $DEBUG and print STDERR "[title=$title]\n";
    }

    # A HREF 󥯥ѴХѥˤ

    $content =~ s#(< (?:A|LINK) \s[^>]*? HREF=)
                  ('[^'>]+'|"[^">]+"|[^">\s]+)
                  ((?:\s[^>]*)? >)
                 #&conv_a_href_tag( $1, $2, $3, $argurl )#gexi;
    $content =~ s#(< (?:SCRIPT|IFRAME|EMBED) \s[^>]*? SRC=)
                  ('[^'>]+'|"[^">]+"|[^">\s]+)
                  ((?:\s[^>]*)? >)
                 #&conv_a_href_tag( $1, $2, $3, $argurl )#gexi;
    $content =~ s#(< (?:FORM) \s[^>]*? ACTION=)
                  ('[^'>]+'|"[^">]+"|[^">\s]+)
                  ((?:\s[^>]*)? >)
                 #&conv_a_href_tag( $1, $2, $3, $argurl )#gexi;

    # IMG ѴcidˤޤȤ

    my $filelist = {};
    $content =~ s#(< (?:IMG|INPUT) \s[^>]*? SRC=)
                  ('[^'>]+'|"[^">]+"|[^">\s]+)
                  ((?:\s+[^>]*)? >)
                 #&conv_img_tag( $1, $2, $3, $filelist )#gexi;
    $content =~ s#(< (?:BODY|TABLE|TR|TD) \s[^>]*? BACKGROUND=)
                  ('[^'>]+'|"[^">]+"|[^">\s]+)
                  ((?:\s+[^>]*)? >)
                 #&conv_img_tag( $1, $2, $3, $filelist )#gexi;
    $DEBUG and print STDERR "[img=",scalar(keys %$filelist)," tags]\n";

    # եɤ

    my $imgname = {};
    my $filedata = {};
    foreach my $cid ( sort keys %$filelist ) {

        # URLη
        my $imglink = &relative_url( $argurl, $filelist->{$cid} );

        # ե̾μ
        my $imgfile = ( $imglink =~ m#([^/]+)$# )[0];
        $imgname->{$cid} = $imgfile;
        $DEBUG and print STDERR "[$cid=$imgfile]\n";

        # ǡ(Хʥ)μ
        my( $imgraw, $err ) = $obj->http_download( $imglink );
        next if ( $imgraw eq "" );
        $filedata->{$cid} = $imgraw;
    }

    # ᡼إå

    my $head_ctype = sprintf( 'multipart/related; boundary="%s"', $BOUNDREL );
    my $head_date = &get_date_string( time(), $obj->{arg}->{TZ} );
    my $head_bits = "8bit";
    $head_bits = "7bit" if ( $encode =~ /^(ISO-2022-JP|US-ASCII)/i );
    $head_bits = "7bit" if $obj->{arg}->{"HTML_BASE64"};
    $head_bits = "7bit" if $obj->{arg}->{"HTML_QP"};
    my $outhead = {
        "Date"          =>  $head_date,
        "Subject"       =>  $title,
        "Content-Type"  =>  $head_ctype,
        "MIME-Version"  =>  "1.0",
        "Content-Transfer-Encoding" =>  $head_bits,
        "X-Mailer"      =>  $obj->{arg}->{"USER_AGENT"},
    };

    # set_header ͽꤵ줿إåǾ񤭤

    if ( ref $obj->{header} ) {
        foreach my $key ( keys %{$obj->{header}} ) {
            $outhead->{$key} = $obj->{header}->{$key};
        }
    }

    my $outdata = [];

    # ᡼إå

    foreach my $key ( sort keys %$outhead ) {
        my $val = $outhead->{$key};
        $val =~ s/\s+/ /sg;                 # Ϣ³1Ĥ
        $val =~ s/^\s+//s;                  # ͤƬζϺ
        $val =~ s/\s+$//s;                  # ͤζ
        my $line = sprintf( "%s: %s\n", $key, $val );
        push( @$outdata, $line );           # ᡼إå
        $DEBUG and print STDERR "[$key=$val]\n";
    }
    push( @$outdata, "\n" );                # ᡼إåλ

    # ᡼ʸ

    push( @$outdata, "$MULTIPART_MESS\n" );
    push( @$outdata, "\n" );
    push( @$outdata, "--$BOUNDREL\n" );
    push( @$outdata, "Content-Type: multipart/alternative; ".
                     "boundary=\"$BOUNDALT\"\n" );
    push( @$outdata, "\n" );

    # ƥȥѡ

    my( $text_body, $text_code ) = $obj->get_text();
    $text_code ||= $encode;
    my $text_cset = "; charset=\"$text_code\"" if $text_code;
    if ( $text_body ne "" ) {
        push( @$outdata, "--$BOUNDALT\n" );
        push( @$outdata, "Content-Type: text/plain$text_cset\n" );
        push( @$outdata, "Content-Transfer-Encoding: $head_bits\n" );
        push( @$outdata, "\n" );
        push( @$outdata, $text_body );    # ƥȥѡ
        push( @$outdata, "\n" );
    }

    # ȣԣ̥ͣѡ

    my $html_body;
    my $html_bits;
    my $html_cset = "; charset=\"$encode\"" if $encode;
    if ( $obj->{arg}->{"HTML_BASE64"} ) {
        $html_body = MIME::Base64::encode( $content );
        $html_bits = "Base64";
    } elsif ( $obj->{arg}->{"HTML_QP"} ) {
        $html_body =~ s/([\=\x7F-\xFF])/sprintf("=%02X",ord($1))/ge;
        $html_bits = "Quoted-Printable";
    } else {
        $html_body = $content;
        $html_bits = ( $content =~ /[\x80-\xFF]/ ) ? "8bit" : "7bit";
    }
    $DEBUG and print STDERR "[Content-Transfer-Encoding=$html_bits]\n";

    push( @$outdata, "--$BOUNDALT\n" );
    push( @$outdata, "Content-Type: text/html$html_cset\n" );
    push( @$outdata, "Content-Transfer-Encoding: $html_bits\n" );
    push( @$outdata, "\n" );
    push( @$outdata, $html_body );    # ȣԣ̥ͣѡ
    push( @$outdata, "\n" );
    push( @$outdata, "--$BOUNDALT--\n" );   # alternative λ

    # źեեѡȡʲ

    foreach my $cid ( sort keys %$filedata ) {
        my $ext = ( $imgname->{$cid} =~ /\.(\w+)$/ )[0] || "gif";
        $ext =~ tr/A-Z/a-z/;
        my $map = {
            jpg     =>  "image/jpeg",
            jpeg    =>  "image/jpeg",
            gif     =>  "image/gif",
            png     =>  "image/png",
            bmp     =>  "image/bmp",
            html    =>  "text/html",
            htm     =>  "text/html",
            hdml    =>  "text/x-hdml",
            css     =>  "text/css",
            js      =>  "application/x-javascript",
            swf     =>  "application/x-shockwave-flash",
        };
        my $ctype = $map->{$ext} || "application/octet-stream";
        my $imgb64 = MIME::Base64::encode( $filedata->{$cid} );
        push( @$outdata, "--$BOUNDREL\n" );
        push( @$outdata, "Content-Type: $ctype; ".
                         "name=\"$imgname->{$cid}\"\n" );
        push( @$outdata, "Content-Disposition: inline; ".
                         "filename=\"$imgname->{$cid}\"\n" );
        push( @$outdata, "Content-Id: <$cid>\n" );
        push( @$outdata, "Content-Transfer-Encoding: base64\n" );
        push( @$outdata, "\n" );
        push( @$outdata, $imgb64 );         # ǡ
        push( @$outdata, "\n" );
    }

    # ᡼ʸλ

    push( @$outdata, "--$BOUNDREL--\n" );

    my $joindata = join( "", @$outdata );   # ǡΤ
    $joindata;                              
}
# ------------------------------------------------------------------------
#   IMG cidˤ
# ------------------------------------------------------------------------
sub conv_img_tag {
    my( $prefix, $src, $suffix, $imghash ) = @_;
    return unless ref $imghash;

    # "" ǰϤޤƤ
    $src = $1 if ( $src =~ /^["'](.*)["']$/s );

    # cid  img01 饫ȥå
    my $cnt = scalar keys %$imghash;
    my $cid = sprintf( "cid%02d", $cnt + 1 );

    # ƱȤäƤƱ cid Ȥ
    foreach my $prev ( sort keys %$imghash ) {
        if ( $imghash->{$prev} eq $src ) {
            $cid = $prev;
            last;
        }       
    }

    $imghash->{$cid} = $src;

    my $ret = sprintf( '%s"cid:%s"%s', $prefix, $cid, $suffix );
    $ret;
}
# ------------------------------------------------------------------------
#   Х󥯤
# ------------------------------------------------------------------------
sub relative_url {
    my $baseurl = shift or return;
    my $linkurl = shift or return;

    if ( $linkurl =~ m#^(https?|ftp|mailto|tel):# ) {
        # Х󥯤ξϤΤޤ֤
        return $linkurl;
    } elsif ( $linkurl =~ m/^#/ ) {
        ##ɽʥ󥯤ξ
        return $linkurl;
    } elsif ( $linkurl =~ m#^/# ) {
        # Хѥ
        my $basehost = ( $baseurl =~ m#^(\w+://[\w\.\-]+)# )[0];
        return $basehost.$linkurl;
    } else {
        # Х󥯤ξϷ׻
        my $basedir = ( $baseurl =~ m#^(.*)(/[^/]*)$# )[0];
        my $linkto = $basedir."/".$linkurl;
        $linkto =~ s#/\./#/#;
        return $linkto;
    }
}
# ------------------------------------------------------------------------
#   <A HREF=""> ν
# ------------------------------------------------------------------------
sub conv_a_href_tag {
    my( $prefix, $href, $suffix, $base ) = @_;

    # "" ǰϤޤƤ
    $href = $1 if ( $href =~ /^["'](.*)["']$/s );

    # Хб
    my $url = &relative_url( $base, $href );
    join( "", $prefix, '"', $url, '"', $suffix );
}
# ------------------------------------------------------------------------
#   Date: إåѤʸ
# ------------------------------------------------------------------------
sub get_date_string {
    my $utc = shift || time();
    my $tz = shift;
    my $WDAYNAME  = [qw( Sun Mon Tue Wed Thu Fri Sat )];
    my $MONTHNAME = [qw( Jan Feb Mar Apr May Jun
                         Jul Aug Sep Oct Nov Dec )];
    my( $sec, $min, $hour, $day, $month, $year, $wday ) = localtime($utc);
    my $date = sprintf( "%s, %2d %s %4d %02d:%02d:%02d %s",
        $WDAYNAME->[$wday], $day, $MONTHNAME->[$month],
        $year+1900, $hour, $min, $sec );
    $date .= " $tz" if $tz;
    $date;
}
# ------------------------------------------------------------------------
#   HTML ʸɤȽꤹ
#   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=Shift_JIS"> 
# ------------------------------------------------------------------------
sub detect_charset {
    my $obj = shift or return;
    my $ref = $obj->get_html_ref() or return;               # ʸ

    # META 鼫ưФ

    if ( $$ref =~ m/<meta (([^\>\"\']|"[^\"]*"|'[^\']*')+)>/si ) {
        my $args = $1;
        $DEBUG and print STDERR "[meta=$args]\n";
        my $hash = {};
        while ( $args =~ m/([^\s\=\'\"]+)=
                           ([^\>\"\'\s]+|"[^\"]*"|'[^\']*')/sgx ) {
            my( $key, $val ) = ( $1, $2 );
            $key =~ tr/a-z/A-Z/;
            $val =~ s/^["'](.*)["']$/$1/s;
            $hash->{$key} = $val;
#           $DEBUG and print STDERR "[META:$key=$val]\n";
        }
        if ( $hash->{"HTTP-EQUIV"} =~ /^Content-Type/i ) {
            $DEBUG and print STDERR "[Content-Type=",$hash->{"CONTENT"},"]\n";
            if ( $hash->{"CONTENT"} =~ /;\s*charset=["']?([^\'\"\s]+)/i ) {
                $DEBUG and print STDERR "[charset=$1]\n";
                return $1;
            }
        }
    }

    # ISO-2022-JP ץ󥹤¸ߤʤޤʤġ

    return "ISO-2022-JP" if ( $$ref =~ m/\e\$\B/ );

    # Ԥʬ䤹

    my $lines = [ grep {/[\x80-\xFF]/} split( /[\r\n]+/, $$ref )];

    # 128255 ʤСUS-ASCII 

    return "US-ASCII" unless scalar @$lines;

    # Shift_JIS ˥ޥå뤫ǧ
    # ASCII             21-7E
    # ȾҲ̾        A1-DF
    # JIS-X-0208-1997   81-9F|E0-EF / 40-7E|80-FC

    if ( $obj->{arg}->{DETECT_SJIS} ) {
        my $RE_ASC1  = '[\x00-\x7F]';                       # ASCIIʸ
        my $RE_SJIS  = '[\x81-\x9F\xE0-\xEF][\x40-\x7E\x80-\xFC]';  # ʸ
        my $RE_KANA  = '[\xA1-\xDF]';                       # SJISȾѥʸ
        my $RE_EMOJI = '[\xF0-\xFC][\x40-\x7E\x80-\xFC]';   # ĥʸ
        my $RE_VODA  = '\x1B\x24[GEFOPQ][\x20-\x7F]+\x0F?'; # Vodafoneʸ
        my $not_sjis;
        foreach ( @$lines ) {
            unless ( /^($RE_ASC1|$RE_SJIS|$RE_KANA|$RE_EMOJI|$RE_VODA)+$/s ) {
                $not_sjis ++;                               # Shift_JISǤϤʤ
                last;
            }
        }
        return "Shift_JIS" unless $not_sjis;
    }

    # EUC-JP ˥ޥå
    # ASCII             21-7E
    # JIS X 0208:1997   A1-FE / A1-FE
    # ȾҲ̾        8E / A1-DF
    # JIS X 0212:1990   8F / A1-FE / A1-FE

    if ( $obj->{arg}->{DETECT_EUCJP} ) {
        my $RE_ASC2   = '[\x00-\x7F]';                      # ASCIIʸ
        my $RE_EUCJP  = '[\xA1-\xFE][\xA1-\xFE]';           # EUC-JP ʸ
        my $RE_EUCSS2 = '\x8E[\xA1-\xDF]';                  # SS2 Ⱦѥʸ
        my $RE_EUCSS3 = '\x8F[\xA1-\xFE]';                  # SS3 JIS-X-0212
        my $not_eucjp;
        foreach ( @$lines ) {
            unless ( /^($RE_ASC2|$RE_EUCJP|$RE_EUCSS2|$RE_EUCSS3)+$/s ) {
                $not_eucjp ++;                              # EUC-JP ǤϤʤ
                last;
            }
        }
        return "EUC-JP" unless $not_eucjp;
    }

    # UTF-8 ˥ޥåBMP̤Τߡ

    if ( $obj->{arg}->{DETECT_UTF8} ) {
        my $RE_ASC3  = '[\x00-\x7F]';                       # ASCIIʸ
        my $RE_UTF8A = '[\xC0-\xDF][\x80-\xBF]';            # UTF-81
        my $RE_UTF8B = '[\xE0-\xEF][\x80-\xBF]{2}';         # UTF-82
        my $not_utf8;
        foreach ( @$lines ) {
            unless ( /^($RE_ASC3|$RE_UTF8A|$RE_UTF8B)+$/s ) {
                $not_utf8 ++;                               # UTF-8 ǤϤʤ
                last;
            }
        }
        return "UTF-8" unless $not_utf8;
    }

    # ꤷʤä

    undef;
}
# ------------------------------------------------------------------------
#   HTML ɤƤ
# ------------------------------------------------------------------------
sub http_download {
    my $obj = shift or return;
    my $httpurl= shift or return;
    $DEBUG and print STDERR "[URL=$httpurl]\n";
    return $obj->{cache}->{$httpurl} if defined $obj->{cache}->{$httpurl};

    my $agent = new LWP::UserAgent() or return;
    $agent->agent( $obj->{arg}->{"USER_AGENT"} );
#   $DEBUG and print STDERR "[USER_AGENT=",$obj->{arg}->{"USER_AGENT"},"]\n";
    my $request = new HTTP::Request( GET => $httpurl ) or return;
    my $response = $agent->request( $request ) or return;
    $response->is_success() or return;

    my $data = $response->content();
    $DEBUG and print STDERR "[content=",length($data)," bytes]\n";

    $obj->{cache}->{$httpurl} = $data;
}
# ----------------------------------------------------------------
#   Perl ⥸塼ɲäɤ߹
# ----------------------------------------------------------------
sub auto_require {
    my $pm = shift or return;
    $DEBUG and print "[require=$pm]\n";
    eval "require '$pm';";
    die "$_[0] - $@\n" if $@;
}
# ------------------------------------------------------------------------
;1;
# ------------------------------------------------------------------------
