# ----------------------------------------------------------------
#   EmailJP.pl - Send mail with Net::SMTP (add Date: header)
#   Copyright 2001-2004 Kappe Inc. All rights reserved.
# ----------------------------------------------------------------
#   2001/05/14  襢ɥ쥹μФȤС
#   2002/12/25  RCPT ޥɥ顼ªdebug ץб
#   2003/06/13  ʸɻб­ʤإåưղ
#   2003/06/26  إåɲäƬˤ
#   2003/07/01  ʣSMTPФǽ
#   2004/07/05  ХưȽ̡Message-Id: 
#   2004/10/28  Encode561EmojiTransEscapeSJISEscapeJIS б
#   2004/11/07  POD 򾯤ޤ
# ----------------------------------------------------------------
    use strict;
    package EmailJP;
    use vars qw( $VERSION $DEBUG );
# ----------------------------------------------------------------
    $VERSION = "0.01";
# ----------------------------------------------------------------
=head1 NAME

    EmailJP.pm -- Send mail with Net::SMTP (add Date: header)

=head1 SYNOPSIS

    # ñʻȤʥإå򻲾Ȥư襢ɥ쥹
    use EmailJP;
    my $count = &EmailJP::sendmail( mail => $text );

    # ¤λȤʰ襢ɥ쥹Ū˻ꤹ
    use EmailJP;
    my $server;
    $server = "127.0.0.1";                      # SMTP
    $server = [qw( 192.168.0.1 127.0.0.1 )];    # ʣǽ
    my $count = &EmailJP::sendmail( 
        server   =>  $server,        # SMTP
        hello    =>  "localhost",    # HELLO
        timeout  =>  5,              # ॢ
        return   =>  $return_path,   # 顼
        to       =>  $rcpt_to,       # ᡼밸
        head     =>  $mail_head,     # ᡼إå
        body     =>  $mail_body,     # ᡼ʸ
        charset  =>  "iso-2022-jp",  # ʸɤ JIS
        internal =>  "EUC-JP"        # ʸɤ EUC
    );

=head1 DESCRIPTION

EmailJP ⥸塼ϡܸޤ᡼Ŭڤʷޤ

=head2 OPTIONS

sendmail() ؿǤϰʲΥץǤޤ

server => SMTPХۥIPɥ쥹

    EmailJP ᡼ݡǥեȤ 127.0.0.1ʼۥȡˤ
    SMTP ³ƥ᡼ޤ
    SMTP ³Υ᡼륵IPɥ쥹ѹϡ
    server ץǻꤷƤ
    ؤΥե󥹤ʣΥ᡼륵Ф󤷤ϡ
    1ܤΥ᡼륵ФߤƤ
    2ܰʹߤΥ᡼륵Фؽ³ޤ
    ŪѲǽʥ᡼륵Ф󤷤ƤȤ򤪴ᤷޤ

hello => HELLOʸ

    SMTP ³ HELO ޥɤΰꤷޤ
    ǥեȤǤ localhost Ȥʤޤ
    ΤޤޤǤ̾ꤢޤ

timeout => ॢÿ

    SMTP ³Υॢÿꤷޤ

return => 顼ֿ襢ɥ쥹

    ᡼λ˥顼ȯˡ
    SMTP ФΤ륢ɥ쥹ꤷޤ
    ꤷʤϡ᡼إå Return-Path: ԤȤޤ
    顼᡼뤬Τ EmailJP ǡ
    EmailJP Ԥϡñ˵֤ޤ

to => ᡼밸襢ɥ쥹

    ᡼ΰ襢ɥ쥹ꤷޤ
    ꤷʤϡ᡼إå To: Cc: Bcc: ԤȤޤ


internal => ʸ

    sendmail() ؿƤӽФ¦ʸɤϡ
    ǥեȤ EUC-JP Ȥߤʤޤ
    EUC-JP ʳʸ(UTF-8ʤ)ѤƤϡ
    internal ץǻꤷƤ
    Shift_JISUTF-8 ʤɤѤǤޤ

charset => ʸ

    ᡼ʸɤϡǥեȤ iso-2022-jp Ȥʤޤ
    ᡼ʸ &#xHHHH; γʸɤޤǤꡢ
    ᡼ΰ NTT ɥӥɥ쥹ޤǡ
     auTU-KAVodafone ηӥɥ쥹ޤޤʤϡ
    NTT ɥѳʸʸʤ뤿 Shift_JIS Ȥʤޤ
    ʳʸɤϡcharset ץ
    ꤷƤ
    Shift_JISUTF-8 ʤɤѤǤޤ

head => ᡼إå
body => ᡼ʸ

    ᡼Υإåʸꤷޤ
    ᡼إåʸͽΤƤϡ
     mail ץꤷƤ

mail => ᡼إåʸ

    ᡼Υإåʸꤷޤ
    إåʸδ֤ˤ϶ԡߣɬפǤ
    ᡼إåʸͽʬΥƤϡ
    嵭 headbody ץꤷƤ

=head2 DEFAULT MAIL HEADER

mail ץޤ head ץǻꤵ줿إå
ɬܤΥإå̵ϡΤ褦ʥإåưղäޤ

    ɸࡧJISξ
    Date: Fri, 13 Jun 2003 03:17:01 +0900
    MIME-Version: 1.0
    Content-Type: text/plain; charset="ISO-2022-JP"
    Content-Transfer-Encoding: 7bit

    Shift_JISξ
    Date: Fri, 13 Jun 2003 03:17:01 +0900
    MIME-Version: 1.0
    Content-Type: text/plain; charset="Shift_JIS"
    Content-Transfer-Encoding: 8bit

=head2 E-MAIL FOR PC

PCΥ᡼ˡϥ䡢Ωκʤɤ IBM ĥޤ
EscapeJIS.pm ⥸塼ˤʸǤޤ

    CP932   UCS2    ­ 
    ------  ------  ---------- 
    FBFC    9AD9    ϥ 
    FAB1    FA11    Ωܲ 
    FBB9    9127    Ȥʿ 

¦Σϣӡ᡼륽եȤˤäƤɽǤʤ
ޤOutlook ExpressBecky! 2 ǤɽǤޤ

=head2 E-MAIL FOR PHONE

᡼ʸʸɤ̾ISO-2022-JP (JIS) Ȥʤޤ
᡼ʸ &#xHHHH; γʸɤޤǤꡢ
᡼ΰ NTT ɥӥɥ쥹ޤǡ
 auTU-KAVodafone ηӥɥ쥹ޤޤʤϡ
NTT ɥѳʸʸʤ뤿 Shift_JIS Ȥʤޤ

᡼ʸ &#xHHHH; γʸɤޤǤꡢ
᡼ΰ auTU-KA ηӥɥ쥹ޤǡ
 NTT ɥ⡦Vodafone ηӥɥ쥹ޤޤʤϡ
EmojiTrans.pm ⥸塼Ѥơ
NTT ɥѤγʸɤ auTU-KA ѤλʸɤѴޤ

᡼ʸ &#xHHHH; γʸɤޤǤꡢ
᡼ΰ Vodafone ηӥɥ쥹ޤǡ
 NTT ɥ⡦auTU-KA ηӥɥ쥹ޤޤʤϡ
EmojiTrans.pm ⥸塼Ѥơ
NTT ɥѤγʸɤ Vodafone ѤλʸɤѴޤ

ˤꡢNTT ɥѤγʸɤޤ᡼ʸѰդ
NTT ɥ⡦auTU-KAVodafone ƤΥꥢФƳʸޤ᡼
뤳ȤǤޤ

=head1 COPYRIGHT

    Copyright 2004 Kawasaki Yusuke <u-suke@kawa.net>
    http://www.kawa.net/

=cut
# ----------------------------------------------------------------
#   ƥ⥸塼ɤ߹ߤ
# ɬפʥ⥸塼ϼưŪɤ߹ޤޤ
# ----------------------------------------------------------------
    use Net::SMTP;
    use Encode561;
    use EmojiTrans;
#   use EscapeSJIS;
#   use EscapeJIS;
#   use EscapeUTF8;
#   use MIME::Base64;
#   use Jcode;
# ----------------------------------------------------------------
#   ǥХå⡼
# ----------------------------------------------------------------
#   $DEBUG ++;
# ----------------------------------------------------------------
#   
# ----------------------------------------------------------------
    my $WORK_CHARSET = "EUC-JP";        # or "UTF-8"
    my $OUT_CHARSET  = "ISO-2022-JP";   # or "UTF-8", "Shift_JIS"
    my $DOCOMO_CHARSET = "Shift_JIS";   # ɥ
    my $SMTP_SERVER  = "127.0.0.1";
    my $SMTP_HELLO   = "localhost";
    my $TIMEZONE     = "+0900";
    my $MIME_VERSION = "1.0";
    my $SMTP_TIMEOUT = 3;
    my $MAIL_COMMAND = "/usr/sbin/sendmail -oi";
# ----------------------------------------------------------------
#   Content-Transfer-Encoding: Ǥʤ󥳡ǥ󥰤
# ----------------------------------------------------------------
    my $NOT_8BIT_CODE = {
        "iso-2022-jp"   =>  "7bit",
    };
# ----------------------------------------------------------------
#   ͤǡJcode.pm ѤΥ̾ꤵ줿Ѵޥå
# ----------------------------------------------------------------
    my $JCODE2CHARSET = {
        jis     =>  "ISO-2022-JP",
        euc     =>  "EUC-JP",
        sjis    =>  "Shift_JIS",
        utf8    =>  "UTF-8",
    };
# ----------------------------------------------------------------
#       ᡼
# ----------------------------------------------------------------
sub sendmail {
    my $hash = { @_ };
    my $head = $hash->{head};
    my $body = $hash->{body};
    my $wait = $hash->{timeout} || $SMTP_TIMEOUT;   # SMTPॢ
    my $from = $hash->{return};
    my $rcpt = $hash->{to};
    my $server = $hash->{server} || $SMTP_SERVER;
    my $hello  = $hash->{hello}  || $SMTP_HELLO;
    my $outcode = $hash->{charset};                     # charset= 
    $outcode ||= $JCODE2CHARSET->{$hash->{jcode}};      # СȤθߴ
    my $workcode = $hash->{internal} || $WORK_CHARSET;
    my $command = $hash->{command} || undef;            # ޥɤ

    $DEBUG ++ if $hash->{debug};        # ǥХå2002/12/25

    # إåʸڤʬγ

    if ( $head eq "" && $body eq "" && defined $hash->{mail} ) {
        my $mail = $hash->{mail};
        $mail = join( "", @$mail ) if ref $mail;
        $mail =~ s/\r?\n/\n/sg;
        $mail =~ s/\r/\n/sg;
        ( $head, $body ) = split( /(?:\n\r?\n|\r\n?\r)/, $mail, 2 );
    } else {
        $head =~ s/\r?\n/\n/sg;
        $head =~ s/\r/\n/sg;
        $body =~ s/\r?\n/\n/sg;
        $body =~ s/\r/\n/sg;
    }

    # &#xHHHH; γʸȤäƤ

    my $use_emoji;
    $use_emoji ++ if ( $head =~ /\&\#/ );
    $use_emoji ++ if ( $body =~ /\&\#/ );
    $DEBUG and print "[USE_EMOJI=$use_emoji]\n";

    # إå̵̤ʶ

    $head =~ s/[\r\n]+/\n/sg;
    $head =~ s/^\s+//s;
    $head =~ s/\s+$//s;

    # пͥɥ쥹μФ

    $from ||= ( $head =~ /^Return-Path:(?:[^\n]|\n[\040\t])*?
        ([^\000-\040\"\'\<\>\(\)\@\,]+\@(?:[\w\-]+\.)+\w+)/mx )[0];
    $from ||= ( $head =~ /^From:       (?:[^\n]|\n[\040\t])*?
        ([^\000-\040\"\'\<\>\(\)\@\,]+\@(?:[\w\-]+\.)+\w+)/mx )[0];
    $DEBUG and print "[FROM=$from]\n";
    die "Sender address is not defined.\n" if ( $from eq "" );

    # 襢ɥ쥹μФ

    if ( ! ref $rcpt ) {
        if ( $rcpt eq "" ) {
            $rcpt = [];
            foreach my $line ( $head =~ /^(?:To|Cc|Bcc):
                                         ((?:[^\n]+|\n[\040\t])+)/mxg ) {
                foreach my $addr ( $line =~ /([^\000-\040\"\'\<\>\(\)\@\,]+
                                             \@(?:[\w\-]+\.)+\w+)/xg ) {
                    push( @$rcpt, $addr );
                }
            }
        } else {
            $rcpt = [ $rcpt ];
        }
    }
    $DEBUG and print "[RCPT=",($#$rcpt+1),"]\n";
    die "Receipt address is not defined.\n" if ( $#$rcpt < 0 );

    # ðΥɥ쥹ǧ

    my $user_agent = &mobile_user_agent( $rcpt );
    $DEBUG and print "[USER_ANGET=$user_agent]\n";

    # Date: ԤʤƬɲä

    my $date = ( $head =~ /(?:^|[\r\n])Date:
                           (?:[^\n]|\n[\040\t])*?(\S.*)/is )[0];
    if ( $date eq "" ) {
        $date = &get_date_string();
        $head = "Date: ".$date."\n".$head if $date;
    }
    $DEBUG and print "[Date=$date]\n";

    # Content-Type: ԤʸɤꤵƤФ˽

    my $ctline = ( $head =~ /(?:^|[\r\n])Content-Type:
                            (?:[^\n]|\n[\040\t])*?(\S.*)/isx )[0];
    if ( $ctline =~ m#^text/.*;\s*charset="?([^"]+)#isx ) {
        $outcode = $1;
    }
    # ϥɤ̤ǡ褬ɥΤߤǡ
    # ʸꤵƤʾϡShift_JIS Ȥ

    unless ( $outcode ) {
        if ( $use_emoji && $user_agent eq "DoCoMo/" ) {
            $outcode ||= $DOCOMO_CHARSET;
        }
        $outcode ||= $OUT_CHARSET;
    }

    # Content-Type: ԤʤƬɲä

    if ( $ctline eq "" && $outcode ) {
        $ctline = "text/plain; charset=".$outcode;
        $head = "Content-Type: ".$ctline."\n".$head;
    }
    $DEBUG and print "[Content-Type=$ctline]\n";
    $DEBUG and print "[charset=$outcode]\n";

    # Content-Transfer-Encoding: ԤʤƬɲä

    my $ctenc = ( $head =~ /(?:^|[\r\n])Content-Transfer-Encoding:
                            (?:[^\n]|\n[\040\t])*?(\S.*)/isx )[0];
    if ( $ctenc eq "" ) {
        $ctenc = "8bit";
        $ctenc = $NOT_8BIT_CODE->{$outcode} if $NOT_8BIT_CODE->{$outcode};
        $head = "Content-Transfer-Encoding: ".$ctenc."\n".$head;
    }
    $DEBUG and print "[Content-Transfer-Encoding=$ctenc]\n";

    # MIME-Version: ԤʤƬɲä

    my $mimever = ( $head =~ /(?:^|[\r\n])MIME-Version:
                              (?:[^\n]|\n[\040\t])*?(\S.*)/isx )[0];
    if ( $mimever eq "" ) {
        $mimever = $MIME_VERSION;
        $head = "MIME-Version: ".$mimever."\n".$head;
    }
    $DEBUG and print "[MIME-Version=$mimever]\n";

    # Message-Id: ԤʤƬɲä

    my $messid = ( $head =~ /(?:^|[\r\n])Message-Id:
                             (?:[^\n]|\n[\040\t])*?(\S.*)/isx )[0];
    if ( $messid eq "" ) {
        $messid = &gen_message_id( $from );
        $head = "Message-Id: ".$messid."\n".$head if $messid;
        $DEBUG and print "[Message-Id=$messid]\n";
    }

    # ʸѴ

    if ( $workcode ne $outcode ) {
        &require_or_die( "Encode561.pm" ) unless defined $Encode561::VERSION;
        $DEBUG and print "[Encode561=$workcode to $outcode]\n";
        Encode561::from_to( \$head, $workcode, $outcode );
        Encode561::from_to( \$body, $workcode, $outcode );
    }

    # ʸȤƤơӰϳʸѴ

    if ( $use_emoji && $user_agent ) {
        &require_or_die( "EmojiTrans.pm" ) unless defined $EmojiTrans::VERSION;
        $DEBUG and print "[EmojiTrans=$user_agent]\n";
        EmojiTrans::translate( \$head, $user_agent );
        EmojiTrans::translate( \$body, $user_agent );
    }

    # ʸʤɤ &#xHHHH; ΥײMIMEإå

    if ( $outcode =~ /^ISO-2022-JP/i ) {
        $DEBUG and print "[EscapeJIS=$outcode]\n";
        &require_or_die( "EscapeJIS.pm" ) unless defined $EscapeJIS::VERSION;
        EscapeJIS::unescape( \$head, $user_agent ) if $use_emoji;
        EscapeJIS::mime_encode( \$head );
        EscapeJIS::unescape( \$body, $user_agent ) if $use_emoji;
    } elsif ( $outcode =~ /^(Shift[\-\_]?JIS|CP932)$/i ) {
        $DEBUG and print "[EscapeSJIS=$outcode]\n";
        &require_or_die( "EscapeSJIS.pm" ) unless defined $EscapeSJIS::VERSION;
        EscapeSJIS::unescape( \$head, $user_agent ) if $use_emoji;
        EscapeSJIS::mime_encode( \$head );
        EscapeSJIS::unescape( \$body, $user_agent ) if $use_emoji;
    } elsif ( $outcode =~ /^UTF-?8$/i ) {
        $DEBUG and print "[EscapeUTF8=$outcode]\n";
        &require_or_die( "EscapeUTF8.pm" ) unless defined $EscapeUTF8::VERSION;
        EscapeUTF8::unescape( \$head, $user_agent ) if $use_emoji;
        EscapeUTF8::mime_encode( \$head );
        # EscapeUTF8::unescape( \$body, $user_agent ) if $use_emoji; # ʸѴʤ
    } else {
        # ʳʸɤξ⥹롼
    }

    # Net::SMTP ǥ᡼뤫ޥɤѤ뤫

    my $use_smtp = 1 unless $command;
    if ( $use_smtp ) {
        &auto_require( "Net/SMTP.pm" ) unless defined $Net::SMTP::VERSION;
        $DEBUG and print "[Net::SMTP=$Net::SMTP::VERSION]\n";
    }
    $use_smtp = undef unless defined $Net::SMTP::VERSION;
    $command ||= $MAIL_COMMAND unless $use_smtp;
    if ( ! $use_smtp && ! $command ) {
        die "Net::SMTP is required for sending e-mail.\n"
    }

    # Net::SMTP ޤϳޥɤǥ᡼

    if ( $use_smtp ) {
        $DEBUG and print "[send_by_smtp]\n";
        &send_by_smtp( $server, $from, $rcpt, $head, $body, $hello, $wait );
    } else {
        $DEBUG and print "[send_by_command=$command]\n";
        &send_by_command( $command, $from, $rcpt, $head, $body );
    }
}
# ----------------------------------------------------------------
#   ޥɤѤ᡼
# ----------------------------------------------------------------
sub send_by_command {
    my( $command, $from, $rcpt, $head, $body ) = @_;

    my $line = join( " ", $command, "-f", $from, @$rcpt );
    open( CMD, "| $line" ) or die "$line - $!\n";
    print CMD $head, "\n\n", $body;
    close( CMD );

    scalar @$rcpt;
}
# ----------------------------------------------------------------
#   Net::SMTP Ѥ᡼
# ----------------------------------------------------------------
sub send_by_smtp {
    my( $server, $from, $rcpt, $head, $body, $hello, $wait ) = @_;

    my $smtp;
    foreach my $host ( ref $server ? @$server : $server ) {
        $DEBUG and print "[SERVER=$host]\n";
        $smtp = Net::SMTP->new( $host, 
                                Hello   =>  $hello,     # HELLO
                                Timeout =>  $wait );    # ॢ
        $DEBUG and print "[SMTP=$smtp]\n";
        last if defined $smtp;
    }
    return undef unless $smtp;

    $DEBUG and print "[FROM=$from]\n";
    $smtp->mail( $from ) or return undef;               # λ

    my $sent = 0;
    foreach my $to ( @$rcpt ) {
        my $recv = $smtp->to( $to ) or return undef;    # λ
        $DEBUG and print "[TO=$to]\n";
        $sent ++;
    }

    $smtp->data() or return undef;      # ᡼γ
    $smtp->datasend( $head );           # ᡼إå
    $smtp->datasend( "\n\n" );          # 
    $smtp->datasend( $body );           # ᡼ʸ
    $smtp->dataend();                   # ᡼νλ
    $smtp->quit;                        # SMTP ³νλ
    $DEBUG and print "[DONE=$sent]\n";
    $sent;
}
# ----------------------------------------------------------------
#   Date: إåѤʸ
# ----------------------------------------------------------------
sub get_date_string {
    my $utc = shift || time();
    my $WDAYNAME  = [qw( Sun Mon Tue Wed Thu Fri Sat )];
    my $MONTHNAME = [qw( Jan Feb Mar Apr May Jun
                         Jul Aug Sep Oct Nov Dec )];
    my( $sec, $min, $hour, $day, $month, $year, $wday ) = localtime($utc);
    my $date = sprintf( "%s, %2d %s %4d %02d:%02d:%02d %s",
        $WDAYNAME->[$wday], $day, $MONTHNAME->[$month],
        $year+1900, $hour, $min, $sec, $TIMEZONE );
    $date;
}
# ----------------------------------------------------------------
#   Message-Id: إåѤʸ
# ----------------------------------------------------------------
sub gen_message_id {
    my $from = shift;
    my $user = ( $from =~ /([\w\-\.]*)\@/ )[0] || $$;
    my $domain = ( $from =~ /\@([\w\-\.]+)/ )[0] || "localhost";
    $user =~ tr/a-z/A-Z/;       # 桼̾ʸˤ
    my( $sec, $min, $hour, $day, $month, $year, $wday ) = localtime();
    $year += 1900;
    $month ++;
    my $messid = sprintf( "<%04d%02d%02d%02d%02d%02d.%04X.%s\@%s>",
                          $year, $month, $day, $hour, $min, $sec, 
                          rand(65536), $user, $domain );
    $messid;
}
# ----------------------------------------------------------------
#   äΥɥ쥹Ҥ˳Ǥ User-Agent ꤹ
# ----------------------------------------------------------------
sub mobile_user_agent {
    my $rcpt = shift or return;

    my $docomo = scalar grep {/\@docomo.ne.jp$/i} @$rcpt;
    my $voda = scalar grep {/\@([a-z]\.vodafone|jp-t[a-z]).ne.jp$/i} @$rcpt;
    my $ezweb = scalar grep {/\@(\w+\.)?(ezweb|tu-ka|ido|tk\w).ne.jp$/i} @$rcpt;

    my $user_agent;
    $user_agent = "DoCoMo/"  if (   $docomo && ! $voda && ! $ezweb );
    $user_agent = "J-PHONE/" if ( ! $docomo &&   $voda && ! $ezweb );
    $user_agent = "KDDI-"    if ( ! $docomo && ! $voda &&   $ezweb );

    $user_agent;
}
# ----------------------------------------------------------------
#   Perl ⥸塼ɲäɤ߹
# ----------------------------------------------------------------
sub auto_require {
    my $pm = shift or return;
    $DEBUG and print "[require=$pm]\n";
    eval "require '$pm';";
}
# ----------------------------------------------------------------
#   Perl ⥸塼ɲäɤ߹
# ----------------------------------------------------------------
sub require_or_die {
    &auto_require( @_ );
    die "$_[0] - $@\n" if $@;
}
# ----------------------------------------------------------------
;1;
# ----------------------------------------------------------------
